<?php // hostnamechgs.php: chok(tue 9 jul 2002)

require_once('handle_vars.php');
vars_save();

require_once('draw.php');
require_once( 'db.php' );
?>



<html>

<head>
<title>Hostnames Changes Report</title>
<link rel="stylesheet" href="style.css">
</head>

<body>





<?php

draw_title('Hostname Changes Report', 1,	// 1 for additional stuff
	'home.php', 'Back to Home Page');









// don't display anything if form wasn't submitted yet

function page_footer()
{
	draw_buttons('home.php', 'Back to Home Page');
	print('</body></html>');
}

if(strlen($submit)==0):
	?>
	<table width=100%>
	<tr>
		<td nowrap width=30>&nbsp;</td>
		<td align=left valign=top>
			<br>
  		<table cellpadding=0 cellspacing=0>
			<tr>
    		<td nowrap width=50 style="border-top:solid 1px #dddddd;
					border-left:solid 1px #dddddd;
					border-bottom:solid 1px #dddddd;" bgcolor=#fafaff>&nbsp;
				</td>
    		<td nowrap valign=top align=left
					style="border-top:solid 1px #dddddd;
					border-bottom:solid 1px #dddddd;" bgcolor=#fafaff>
					<br><br>
    			Please use the form on the right to <br>
    			&nbsp; specify the dates for which you wish <br>
    			&nbsp; to view the hostname changes data.<br>
					<br><br>
    		</td>
    		<td nowrap width=50 style="border-top:solid 1px #dddddd;
					border-right:solid 1px #dddddd;
					border-bottom:solid 1px #dddddd;" bgcolor=#fafaff>&nbsp;
				</td>
    		<td align=right valign=top width=20>
    			<br><br><br>
    			<img src="images/tinybluebullet.gif">
    		</td>
			</tr>
			</table>
		</td>
		<td align=right>
			<?php require_once( 'hostnamechgs_form.php' );?>
		</td>
	</tr>
	</table>
	<?php

	page_footer(); exit();
endif;
flush();






//
//  functions
//


function dateByDaysFromToday( $daysFromToday )
// returns the date specified by how many days from today
// works by subtracting the $day, $mth and $yr accordingly
{
	// retrieve today's day, month and year
	$today = getdate( time() );
	$day = $today['mday'];
	$mth = $today['mon'];
	$yr = $today['year'];

	// subtract the $day first, then subtract month and year progressively
	// ends when $day finally becomes valid, i.e. between 1 && lastDayOfMonth
	for( $day -= $daysFromToday; $day < 1; $day += lastDayOfMonth($mth,$yr) ):
		if( -- $mth < 1 ) {$yr --; $mth = 12;}
	endfor;

	// put leading zero
	if( $mth <= 9 ) $mth = '0' . $mth;
	if( $day <= 9 ) $day = '0' . $day;

	return "$yr-$mth-$day";
}

function lastDayOfMonth( $mth, $yr )
// returns the last day of the given $mth in $yr
{
	for( $day=31; !checkdate($mth,$day,$yr); $day-- );
	return $day;
}




/*
	CGI vars (exact same as found in hostchangequeryform)
	--------
	$by_month				= '05-2001'
	$last_weeks			= 2 ( last 2 weeks )
	$last_days			= 2 ( last 2 days )
	${from|to}_{day|mth|yr} = '2001-05-15'

	$hc_sort_field		= 'IP' (only for this script itself)
	$hc_sort_order		= 'asc' (only for this script itself)

	$use_{by_month|last_weeks|last_days|exact_dates} = 1 | NULL
*/


//
//  process CGI vars
//

// convert nice fields to actual fields
if( strcmp($hc_sort_field,'IP')==0 ) $hc_sort_field = 'ip';
if( strcmp($hc_sort_field,'Old Hostname')==0 ) $hc_sort_field = 'oldhostname';
if( strcmp($hc_sort_field,'New Hostname')==0 ) $hc_sort_field = 'newhostname';
if( strcmp($hc_sort_field,'Date Updated')==0 ) $hc_sort_field = 'updatetime';






function cond_from($from_date)
{
	set_max_from_date($from_date);
	return "updatetime>='$from_date 00:00:00'";
}

function cond_to($to_date)
{
	set_min_to_date($to_date);
	return "updatetime<='$to_date 23:59:59'";
}

function cond_from_to($from_date, $to_date)
{
	$w = array();
	if(strlen($from_date)) $w[] = cond_from($from_date);
	if(strlen($to_date)) $w[] = cond_to($to_date);

	if(sizeof($w)==0) return '0=0'; // always true

	return '(' . join(' and ',$w) . ')';
}

function set_max_from_date($from_date)
{
	global $max_from_days, $max_from_date, $max_from_date_set;

	$days = db_item("select to_days('$from_date')");
	if(!$max_from_date_set || $days>$max_from_days)
		{$max_from_days = $days; $max_from_date = $from_date;
		$max_from_date_set=1;}
}

function set_min_to_date($to_date)
{
	global $min_to_days, $min_to_date, $min_to_date_set;

	$days = db_item("select to_days('$to_date')");
	if(!$min_to_date_set || $days<$min_to_days)
		{$min_to_days = $days; $min_to_date = $to_date;
		$min_to_date_set=1;}
}













$wheres = array();

if($use_by_month):
	// view records by a single month at a time
	if(strlen($by_month)):
	  	$mth = substr($by_month,0,2);
	  	$yr = substr($by_month, 3, 4);

	  	$from_date = "$yr-$mth-01";	// always starts on 1st of month
	  	$to_date = "$yr-$mth-" . lastDayOfMonth($mth,$yr);

		$wheres[] = cond_from_to($from_date,$to_date);
	endif;
endif;

if($use_last_weeks):
	// view records by the last few weeks at a time, $to_date not needed
	if($last_weeks>0):
	  	$from_date = dateByDaysFromToday( $last_weeks * 7 );
		$wheres[] = cond_from($from_date);
	endif;
endif;

if($use_last_days):
	// view records by the last few days at a time, $to_date not needed
	if($last_days>0):
	  	$from_date = dateByDaysFromToday( $last_days );
	  	$wheres[] = cond_from($from_date);
	endif;
endif;

if($use_exact_dates):
	// check values
	$from_date = sprintf('%04d-%02d-%02d', $from_yr, $from_mth, $from_day);
	$to_date = sprintf('%04d-%02d-%02d', $to_yr, $to_mth, $to_day);

	if( strlen($to_date) != 10 || !checkdate($to_mth,$to_day,$to_yr) )
		$to_date = '';
	if( strlen($from_date) != 10 || !checkdate($from_mth,$from_day,$from_yr) )
		$from_date = '';

	$wheres[] = cond_from_to($from_date,$to_date);
endif;










//
//  make the $where and $order_by strings
//

$where = sizeof($wheres)? 'where ' . join(' and ', $wheres) : '';


// order by clause
if( strlen($hc_sort_field)==0 ) $hc_sort_field='updatetime';
if( strlen($hc_sort_order)==0 ) $hc_sort_order='asc';
$order_by = "order by $hc_sort_field $hc_sort_order";
















//
//  gather summary data from the database
//

// find out the earliest date that a record was inserted
$earliest_data = db_item('select ' . db_date_format('min(updatetime)') .
	' from oldhostnames');

$latest_data = db_item('select ' . db_date_format('max(updatetime)') .
	' from oldhostnames');

$data_range = "$earliest_data to $latest_data";

// find out the total number of entries
$total_rows = db_item('select count(ip) from oldhostnames');

// find out the number of entries currently shown
$shown_rows = db_item("select count(ip) from oldhostnames $where");

if($shown_rows>0):
	$earliest_shown = db_item('select ' . db_date_format('min(updatetime)') .
		" from oldhostnames $where");
	$latest_shown = db_item('select ' . db_date_format('max(updatetime)') .
		" from oldhostnames $where");
	$shown_range = "$earliest_shown to $latest_shown";
else:
	$shown_range = 'Not applicable';
endif;

// form the print string for the actual included dates
if($max_from_date_set)
	$max_from_date = db_item('select ' . db_date_format("'$max_from_date'"));
if($min_to_date_set)
	$min_to_date = db_item('select ' . db_date_format("'$min_to_date'"));

if($max_from_date_set && $min_to_date_set)
	$included_range = "$max_from_date to $min_to_date";
elseif($max_from_date_set)
	$included_range = "Since $max_from_date";
elseif($min_to_date_set)
	$included_range = "Until $min_to_date";
else
	$included_range = "All dates";




//
//  table title and summary data
//

?>

<table width=100%>
<tr>
	<td width=30 nowrap>&nbsp;</td>
	<td>
    <?php
		draw_key_values( array(
			array('Earliest data', $earliest_data),
			array('Total data', $total_rows),
   			array('Total shown', $shown_rows),
   			array('Data range', $data_range),
   			array('Included range', $included_range),
	    	array('Shown range', $shown_range)
			), 1 );	// 1 - $columns
		?>
	</td>
	<td align=right>
		<?php require_once( 'hostnamechgs_form.php' ); ?>
	</td>
	</tr>
</table>

<br>







<?php

flush();








//
//  retrieve all data
//

function check_highlight_hostname( $hostname )
// returns a highlighted hostname if it is one of the unusual ones
{
	switch($hostname):
	case(''): $hostname = 'Nil';
	case('Hostname unknown'):
	case('Unspecified Hostname'):
		return "<font color=#ff0000><b>$hostname</b></font>";
	endswitch;

	return $hostname;
}

// get data from database
$fields = array('ip', db_date_format('oldhostname'),
	db_date_format('newhostname'), db_date_format('updatetime'));
$sql = "select " . join(',', $fields) . " from oldhostnames $where $order_by";
$data = db_rows($sql);
$rows_count = sizeof($data);

for( $i=0; $i<$rows_count; $i++ ):

	// the first line '$ip = ...' is necessary!!
	$ip = $data[$i][0]; // don't remove this line
	$data[$i][0] = long2ip($ip);

	// highlight hostnames
	$data[$i][1] = check_highlight_hostname($data[$i][1]);
	$data[$i][2] = check_highlight_hostname($data[$i][2]);

endfor;







//
//  display whole table
//

draw_hr();

// convert actual fields back to nice fields
if( strcmp($hc_sort_field,'ip')==0 ) $hc_sort_field = 'IP';
if( strcmp($hc_sort_field,'oldhostname')==0 ) $hc_sort_field = 'Old Hostname';
if( strcmp($hc_sort_field,'newhostname')==0 ) $hc_sort_field = 'New Hostname';
if( strcmp($hc_sort_field,'updatetime')==0 ) $hc_sort_field = 'Date Updated';

require_once('draw_data_table.php');
$nice_fields	= array( 'IP', 'Old Hostname', 'New Hostname', 'Date Updated' );

$PHP_SELF = 'hostnamechgs.php';

draw_data_table($nice_fields, $data, 0, 0, 'hc_sort_field', 'hc_sort_order', 0);
	// (0,0,0) = ($start_row,$rows_per_page,$delete_buttons)










page_footer();

?>

